#ifndef _NAVERUTIL_H_
#define _NAVERUTIL_H_

#define IE_VERSION_7 7.0f
#define IE_VERSION_8 8.0f

#include <atlstr.h>

class CUtil  
{
public:
	CUtil();
	virtual ~CUtil();

	static BOOL IsIEVersion70();

	static BOOL IsIEVersionRequiredOrHigherVer(const double dRequiredVersion);

	/**
	*@fn static BOOL FixInvalidNaverSearchScope();
	*@brief ˻ ڿ Naver ִٸ ش  ùٸ   Ѵ.
	**/
	static BOOL FixInvalidNaverSearchScope();

	/**
	*@fn void CreateUserModeKey( CAtlString &strKeyName, HKEY &hParent )
	*@brief User α   SerchScope Ű  ش.
	**/
	static void CreateUserModeKey( /*OUT*/ CAtlString &strKeyName, /*OUT*/ HKEY &hParent );

	/**
	*@fn static BOOL IsValidSearchScope(CRegKey &regProviderKey, BOOL &bMSProvideUrl )
	*@brief regProviderKey SearchScope ´ Ȯ, MS ߰  Ȯ Ѵ.
	**/
	static BOOL IsValidSearchScope(CRegKey &regProviderKey, /*OUT*/ BOOL &bMSProvideUrl ); 
	
	/**
	*@fn static void WriteValidSearchScopeInfo(CRegKey &regProviderKey, BOOL bMSProvideUrl )
	*@brief oldProviderKey  ùٸ , MS   츦 ǴϿ URL 
	**/
	static void WriteValidSearchScopeInfo( CRegKey &oldProviderKey, BOOL bMSProvideUrl );

	// Naver Start Page, Search Engine Check Related Function
	static BOOL IsNaverStartPageConfigured();
	static BOOL IsNaverSearchEngineConfigured();
	static BOOL SetNaverStartPage();
	static BOOL SetNaverSearchEngine();
	static BOOL IsWinVista();
	static BOOL GetCurrentExplorerUserSID( CAtlString& userSID);
	static BOOL GetVistaUserLogonName(CAtlString& userName);
	static BOOL IsWow64();
private:
	static BOOL IsNaverProvider( LPCTSTR szDefaultScope );
	static BOOL IsNaverUrl(LPCTSTR url);
	static BOOL IsNaverUrlInternal(LPCTSTR url, const TCHAR* regExp);
	static BOOL IsVistaUserModeLogined(BOOL& isLogin);
	static BOOL GetProcessUsername(HANDLE *phProcess, TCHAR* sname, BOOL bIncDomain);
};

#endif